diff --git src/daemon/common/commonSwarming.ml src/daemon/common/commonSwarming.ml
index 1e018f7..a044c59 100644
--- src/daemon/common/commonSwarming.ml
+++ src/daemon/common/commonSwarming.ml
@@ -2227,166 +2319,168 @@ let select_blocks up =
           if cmp <> 0 then cmp else
 
           (* "WISHES" *)
-	  (* Do what Master asked for *)
-	    let cmp = compare (choice_user_priority c1)
-	      (choice_user_priority c2) in
-	  if cmp <> 0 then cmp else
+          (* Do what Master asked for *)
+            let cmp = compare (choice_user_priority c1)
+              (choice_user_priority c2) in
+          if cmp <> 0 then cmp else
 
           (* "OPTIMIZATIONS" *)
-	    (* Pick really rare gems: if average availability of all
-	       blocks is higher than 5 connected sources, pick in
-	       priority blocks present in at most 3 connected sources;
-	       is that too restrictive ? *)
+            (* Pick really rare gems: if average availability of all
+               blocks is higher than 5 connected sources, pick in
+               priority blocks present in at most 3 connected sources;
+               is that too restrictive ? *)
             let cmp =
               if not need_to_complete_some_blocks_quickly &&
-		mean_availability > 5 &&
-		(choice_availability c1 <= 3 || 
-		 choice_availability c2 <= 3) then
-		  compare (choice_availability c2)
-		    (choice_availability c1)
+                mean_availability > 5 &&
+                (choice_availability c1 <= 3 || 
+                 choice_availability c2 <= 3) then
+                  compare (choice_availability c2)
+                    (choice_availability c1)
               else 0 in
             if cmp <> 0 then cmp else
   
-	  (* try to quickly complete (and validate) chunks; 
-	     if there's only one frontend, each chunk has only one
-	     block, and looking at siblings make no sense *)
-	  let cmp = 
-	    if verification_available && several_frontends then 
-	      compare (choice_other_remaining c2)
-		(choice_other_remaining c1)
-	    else 0 in
-	  if cmp <> 0 then cmp else
-
-	  (* try to quickly complete blocks *)
-	  let cmp = 
-	    compare (choice_unselected_remaining c2)
-	      (choice_unselected_remaining c1) in
-	  if cmp <> 0 then cmp else
-
-	  (* pick blocks that won't require allocating more disk space *)
-	  let cmp =
-	    match choice_preallocated c1, choice_preallocated c2 with
-	    | true, false -> 1
-	    | false, true -> -1
-	    | _ -> 0 in
-	  if cmp <> 0 then cmp else
-
-	  (* "DEFAULT" *)
-	    (* Can't tell *)
-	    0 in
-
-	(* compare a new chunk against a list of best choices numbers (and a
-	   specimen of best choice) *)
-	let keep_best_chunks chunk_blocks_indexes best_choices specimen =
-	  match chunk_blocks_indexes with 
-	  | [] -> best_choices, specimen
-	  | h :: q ->
-	      let this_chunk_specimen = List.fold_left (fun acc n ->
-		let choice = create_choice n up.up_complete_blocks.(n) in
-		let cmp = compare_choices choice acc in
-		if cmp <= 0 then acc
-		else choice) (create_choice h up.up_complete_blocks.(h)) q in
-	      let cmp = compare_choices this_chunk_specimen specimen in
-	      if cmp < 0 then best_choices, specimen
-	      else if cmp > 0 then [chunk_blocks_indexes], this_chunk_specimen
-	      else chunk_blocks_indexes :: best_choices, specimen in
-	
-	let current_chunk_num, current_chunk_blocks_indexes, 
-	  best_choices, specimen =
-	  Array2.subarray_fold_lefti (fun 
-	    ((current_chunk_num, current_chunk_blocks_indexes, 
-	    best_choices, specimen) as acc) n b ->
-	    if not (should_download_block s b) then acc 
-	    else
-	      let chunk_num = t.t_chunk_of_block.(b) in
-	      if chunk_num = current_chunk_num then
-		(current_chunk_num, n :: current_chunk_blocks_indexes,
-		best_choices, specimen)
-	      else 
-		(* different chunk *)
-		match current_chunk_blocks_indexes with
-		| [] -> 
-		    (* no previous chunk *)
-		    (chunk_num, [n], best_choices, specimen)
-		| h :: q ->
-		    let new_best_choices, new_specimen =
-		      keep_best_chunks current_chunk_blocks_indexes best_choices specimen in
-		    (chunk_num, [n], new_best_choices, new_specimen)
-	  ) (-1, [], [], dummy_choice) up.up_complete_blocks 0
-	    (up.up_ncomplete -1) in
-
-	(* last chunk *)
-	let best_choices, specimen = 
-	  keep_best_chunks current_chunk_blocks_indexes best_choices specimen in
-	(* what about up_partial_blocks ? 
-	   currently they're taken care of by linear_select_block
-	   fallback below *)
-
-	if debug_all then print_choice specimen;
-
-	try
-	  let blocks = 
-	    match best_choices with
-	      | [] -> raise Not_found
-	      | [choice] -> choice
-	      | _::_ -> 
-		  let nchoices = List.length best_choices in
-		  List.nth best_choices (Random.int nchoices) in
-
-	  let chunk =
-	    match blocks with
-	    | [] -> assert false
-	    | b :: _ -> t.t_chunk_of_block.(up.up_complete_blocks.(b)) in
+          (* try to quickly complete (and validate) chunks; 
+             if there's only one frontend, each chunk has only one
+             block, and looking at siblings make no sense *)
+          let cmp = 
+            if verification_available && several_frontends then 
+              compare (choice_other_remaining c2)
+                (choice_other_remaining c1)
+            else 0 in
+          if cmp <> 0 then cmp else
+
+          (* try to quickly complete blocks *)
+          let cmp = 
+            compare (choice_unselected_remaining c2)
+              (choice_unselected_remaining c1) in
+          if cmp <> 0 then cmp else
+
+          (* pick blocks that won't require allocating more disk space *)
+          let cmp =
+            match choice_preallocated c1, choice_preallocated c2 with
+            | true, false -> 1
+            | false, true -> -1
+            | _ -> 0 in
+          if cmp <> 0 then cmp else
+
+          (* "DEFAULT" *)
+            (* Can't tell *)
+            0 in
+
+        (* compare a new chunk against a list of best choices numbers (and a
+           specimen of best choice) *)
+        let keep_best_chunks chunk_blocks_indexes best_choices specimen =
+          match chunk_blocks_indexes with 
+          | [] -> best_choices, specimen
+          | h :: q ->
+              let this_chunk_specimen = List.fold_left (fun acc n ->
+                let choice = create_choice n up.up_complete_blocks.(n) in
+                let cmp = compare_choices choice acc in
+                if cmp <= 0 then acc
+                else choice) (create_choice h up.up_complete_blocks.(h)) q in
+              let cmp = compare_choices this_chunk_specimen specimen in
+              if cmp < 0 then best_choices, specimen
+              else if cmp > 0 then [chunk_blocks_indexes], this_chunk_specimen
+              else chunk_blocks_indexes :: best_choices, specimen in
+        
+        let current_chunk_num, current_chunk_blocks_indexes, 
+          best_choices, specimen =
+          Array2.subarray_fold_lefti (fun 
+            ((current_chunk_num, current_chunk_blocks_indexes, 
+            best_choices, specimen) as acc) n b ->
+            if s.s_priorities_bitmap.[b] = priority_zero ||
+              not (should_download_block s b) then acc
+            else
+              let chunk_num = t.t_chunk_of_block.(b) in
+              if chunk_num = current_chunk_num then
+                (current_chunk_num, n :: current_chunk_blocks_indexes,
+                best_choices, specimen)
+              else 
+                (* different chunk *)
+                match current_chunk_blocks_indexes with
+                | [] -> 
+                    (* no previous chunk *)
+                    (chunk_num, [n], best_choices, specimen)
+                | h :: q ->
+                    let new_best_choices, new_specimen =
+                      keep_best_chunks current_chunk_blocks_indexes best_choices specimen in
+                    (chunk_num, [n], new_best_choices, new_specimen)
+          ) (-1, [], [], dummy_choice) up.up_complete_blocks 0
+            (up.up_ncomplete -1) in
+
+        (* last chunk *)
+        let best_choices, specimen = 
+          keep_best_chunks current_chunk_blocks_indexes best_choices specimen in
+        (* what about up_partial_blocks ? 
+           currently they're taken care of by linear_select_block
+           fallback below *)
+
+        if debug_all then print_choice specimen;
+
+        try
+          let blocks = 
+            match best_choices with
+              | [] -> raise Not_found
+              | [choice] -> choice
+              | _::_ -> 
+                  let nchoices = List.length best_choices in
+                  List.nth best_choices (Random.int nchoices) in
+
+          let chunk =
+            match blocks with
+            | [] -> assert false
+            | b :: _ -> t.t_chunk_of_block.(up.up_complete_blocks.(b)) in
 
           if debug_all || !verbose_swarming then begin
-	    lprintf_nl "\nBlocksFound in %d: %d" chunk (List.length blocks);
-	    List.iter (fun n ->
+            lprintf_nl "\nBlocksFound in %d: %d" chunk (List.length blocks);
+            List.iter (fun n ->
               lprintf_n " %d" up.up_complete_blocks.(n)
-	    ) blocks;
-	    lprint_newline ()
-	  end;
+            ) blocks;
+            lprint_newline ()
+          end;
 
 (*
           (* DEBUG *)
-	  let probably_buggy =
-	    List.for_all (fun n ->
-	      let block_num = up.up_complete_blocks.(n) in
-	      match s.s_blocks.(block_num) with
-	      | EmptyBlock -> false
-	      | PartialBlock b ->
-		  block_ranges_for_all (fun r ->
-		    r.range_nuploading > 0) b
-	      | CompleteBlock | VerifiedBlock ->
-		  true) blocks in
-	  if probably_buggy then begin
+          let probably_buggy =
+            List.for_all (fun n ->
+              let block_num = up.up_complete_blocks.(n) in
+              match s.s_blocks.(block_num) with
+              | EmptyBlock -> false
+              | PartialBlock b ->
+                  block_ranges_for_all (fun r ->
+                    r.range_nuploading > 0) b
+              | CompleteBlock | VerifiedBlock ->
+                  true) blocks in
+          if probably_buggy then begin
             lprintf_nl "Probably buggy choice (%d):" chunk;
-	    Array2.subarray_fold_lefti (fun () n b ->
-	      if should_download_block s b then
-		let this_choice = create_choice n b in
-		if List.mem n blocks then lprintf "** "
-		else if List.exists (List.mem n) best_choices then
-		  lprintf "-- "
-		else lprintf "   ";
-		print_choice this_choice;
-		match s.s_blocks.(b) with
-		| EmptyBlock | CompleteBlock | VerifiedBlock -> ()
-		| PartialBlock b ->
-		    let total_uploading =
-		      block_ranges_fold	(fun acc r ->
-			lprintf "%d " r.range_nuploading;
-			  acc + r.range_nuploading) 0 b in
-		    lprintf "total=%d" total_uploading;
-		    lprint_newline ()
-	    ) () up.up_complete_blocks 0 (up.up_ncomplete - 1);
-	  end;
-	  (* /DEBUG *)
+            Array2.subarray_fold_lefti (fun () n b ->
+              if s.s_priorities_bitmap.[b] <> priority_zero &&
+                 should_download_block s b then
+                let this_choice = create_choice n b in
+                if List.mem n blocks then lprintf "** "
+                else if List.exists (List.mem n) best_choices then
+                  lprintf "-- "
+                else lprintf "   ";
+                print_choice this_choice;
+                match s.s_blocks.(b) with
+                | EmptyBlock | CompleteBlock | VerifiedBlock -> ()
+                | PartialBlock b ->
+                    let total_uploading =
+                      block_ranges_fold        (fun acc r ->
+                        lprintf "%d " r.range_nuploading;
+                          acc + r.range_nuploading) 0 b in
+                    lprintf "total=%d" total_uploading;
+                    lprint_newline ()
+            ) () up.up_complete_blocks 0 (up.up_ncomplete - 1);
+          end;
+          (* /DEBUG *)
 *)
 
-	  chunk, List.map (fun n -> permute_and_return up n) blocks
-	with Not_found ->
-	  if !verbose_swarming then
-	    lprintf_nl "select_block: fallback to linear strategy";
-	  linear_select_blocks up
+          chunk, List.map (fun n -> permute_and_return up n) blocks
+        with Not_found ->
+          if !verbose_swarming then
+            lprintf_nl "select_block: fallback to linear strategy";
+          linear_select_blocks up
   with Not_found ->
 
     (* print_s "NO BLOCK FOUND" s; *)
@@ -2415,28 +2509,28 @@ let find_blocks up =
     | FileShared
     | FileNew 
     | FileDownloaded -> 
-	raise Not_found
+        raise Not_found
     | FileDownloading
     | FileQueued ->
-	List.iter (fun b ->
+        List.iter (fun b ->
           let num = b.up_block.block_num in
-	  if debug_all then
-	    lprintf_nl "Client %d unselected %d" (client_num up.up_client) num;
-	  if s.s_nuploading.(num) > 0 then
+          if debug_all then
+            lprintf_nl "Client %d unselected %d" (client_num up.up_client) num;
+          if s.s_nuploading.(num) > 0 then
             s.s_nuploading.(num) <- s.s_nuploading.(num) - 1
-	  else
-	    lprintf_nl "find_blocks: s_nuploading was about to become  negative"
-	) up.up_blocks;
+          else
+            lprintf_nl "find_blocks: s_nuploading was about to become  negative"
+        ) up.up_blocks;
         up.up_blocks <- [];
 
         let chunk, blocks = select_blocks up in
-	List.iter (fun b ->
+        List.iter (fun b ->
           let num = b.up_block.block_num in
-	  if debug_all then
-	    lprintf_nl "Client %d selected %d" (client_num up.up_client) num;
+          if debug_all then
+            lprintf_nl "Client %d selected %d" (client_num up.up_client) num;
           s.s_nuploading.(num) <- s.s_nuploading.(num) + 1;
-	) blocks;
-	up.up_blocks <- blocks;
+        ) blocks;
+        up.up_blocks <- blocks;
         chunk, blocks
   with e ->
     if debug_all then lprintf_nl "Exception %s in find_blocks" (Printexc2.to_string e);
@@ -2459,9 +2553,9 @@ let remove_completed_uploader_ranges up =
     if r.range_nuploading = 0 then
       let b = r.range_block in
       b.block_unselected_remaining <-
-	b.block_unselected_remaining ++ (compute_range_size r);
+        b.block_unselected_remaining ++ (compute_range_size r);
       if b.block_unselected_remaining > b.block_remaining then
-	lprintf_nl "remove_completed_uploader_ranges: block_unselected_remaining is larger than block_remaining";
+        lprintf_nl "remove_completed_uploader_ranges: block_unselected_remaining is larger than block_remaining";
     ) completed_ranges
 
 (** uploader accessors *)
@@ -2525,27 +2619,27 @@ let find_range up range_size =
     match r.range_next with
     | None -> false
     | Some rr ->
-	if rr != r2 ||
-	  r.range_end < r2.range_begin ||
-	  r2.range_nuploading > 0 then false
-	else begin
-	  r.range_end <- r2.range_end;
-	  r.range_next <- r2.range_next;
-	  (match r.range_next with
-	  | None -> ()
-	  | Some r3 ->
-	      r3.range_prev <- Some r);
-	  true
-	end in
+        if rr != r2 ||
+          r.range_end < r2.range_begin ||
+          r2.range_nuploading > 0 then false
+        else begin
+          r.range_end <- r2.range_end;
+          r.range_next <- r2.range_next;
+          (match r.range_next with
+          | None -> ()
+          | Some r3 ->
+              r3.range_prev <- Some r);
+          true
+        end in
 
   remove_completed_uploader_ranges up;
 
   let b, more_blocks =
     match up.up_blocks with
     | [] -> 
-	if debug_all then
-	  lprintf_nl "find_range: uploader had no block selected";
-	raise Not_found
+        if debug_all then
+          lprintf_nl "find_range: uploader had no block selected";
+        raise Not_found
     | b :: more_blocks -> b, more_blocks
   in
   let t = up.up_t in
@@ -2557,135 +2651,136 @@ let find_range up range_size =
   | FileNew
   | FileDownloaded -> 
       lprintf_nl "find_range: file %s in bad state %s" 
-	t.t_s.s_filename (string_of_state (file_state t.t_file));
+        t.t_s.s_filename (string_of_state (file_state t.t_file));
       raise Not_found
   | FileDownloading
   | FileQueued ->
       if debug_all then
-	lprintf_nl "find_range: is there a range of size %Ld in %s for %d ?" 
-	  range_size 
-	  (String.concat " " (List.map (fun b ->
-	    Printf.sprintf "[%Ld-%Ld]" b.up_block_begin b.up_block_end
-	  ) up.up_blocks))
-	  (client_num up.up_client);
+        lprintf_nl "find_range: is there a range of size %Ld in %s for %d ?" 
+          range_size 
+          (String.concat " " (List.map (fun b ->
+            Printf.sprintf "[%Ld-%Ld]" b.up_block_begin b.up_block_end
+          ) up.up_blocks))
+          (client_num up.up_client);
       (* pick the first correct cluster with fewest uploaders 
-	 We're not trying to get a range that's at least as big as
-	 [range_size] bytes - that would prevent partially downloaded
-	 ranges from being completed first *)
+         We're not trying to get a range that's at least as big as
+         [range_size] bytes - that would prevent partially downloaded
+         ranges from being completed first *)
       let rec iter acc r b more_blocks =
-	let correct_range r =
-	  not (in_uploader_ranges r up.up_ranges) &&
-	    r.range_begin < r.range_end &&
-	    r.range_begin >= b.up_block_begin &&
-	    r.range_begin < b.up_block_end in
-	let best_cluster =
-	  if not (correct_range r) then acc
-	  else 
-	    (* find if there are ranges to merge ahead *)
-	    let rec iter_cluster r cluster =
-	      let cluster = { cluster with
-		cluster_ranges = r :: cluster.cluster_ranges;
-		cluster_size = cluster.cluster_size ++ 
-		  (compute_range_size r)
-	      } in
-	      if not allow_merge_ranges ||
-		cluster.cluster_size >= range_size then cluster 
-	      else
-		match r.range_next with
-		| None -> cluster
-		| Some rr ->
-		    if rr.range_begin = r.range_end &&
-		      correct_range rr && rr.range_nuploading = 0 then 
-		      iter_cluster rr cluster
-		    else cluster in
-
-	    let cluster = 
-	      iter_cluster r { dummy_ranges_cluster with
-		cluster_nuploading = r.range_nuploading } in
-	    if debug_all then
-	      lprint_newline ();
-	    if is_dummy_cluster acc then cluster
-	    else
-	      (* find a range with as few uploaders as possible *)
-	      let cmp = compare acc.cluster_nuploading
-		cluster.cluster_nuploading in
-	      if cmp < 0 then acc
-	      else cluster in
-
-	(* fast exit, and why I didn't use an iterator :/ 
-	   Could have used an exception, but I don't like that ;) *)
-	if not (is_dummy_cluster best_cluster) &&
-	  best_cluster.cluster_nuploading = 0 then b, best_cluster
-	else
-	  match r.range_next with
-	  | Some rr -> iter best_cluster rr b more_blocks
-	  | None -> 
-	      match more_blocks with
-	      | [] -> b, best_cluster
-	      | b :: more_blocks -> 
-		  if debug_all || !verbose then
-		    lprintf_nl "find_range: Client %d, next block" 
-		      (client_num up.up_client);
-		  iter best_cluster b.up_block.block_ranges b more_blocks in
+        let correct_range r =
+          not (in_uploader_ranges r up.up_ranges) &&
+            r.range_begin < r.range_end &&
+            r.range_begin >= b.up_block_begin &&
+            r.range_begin < b.up_block_end in
+        let best_cluster =
+          if not (correct_range r) then acc
+          else 
+            (* find if there are ranges to merge ahead *)
+            let rec iter_cluster r cluster =
+              let cluster = { cluster with
+                cluster_ranges = r :: cluster.cluster_ranges;
+                cluster_size = cluster.cluster_size ++ 
+                  (compute_range_size r)
+              } in
+              if not allow_merge_ranges ||
+                cluster.cluster_size >= range_size then cluster 
+              else
+                match r.range_next with
+                | None -> cluster
+                | Some rr ->
+                    if rr.range_begin = r.range_end &&
+                      correct_range rr && rr.range_nuploading = 0 then 
+                      iter_cluster rr cluster
+                    else cluster in
+
+            let cluster = 
+              iter_cluster r { dummy_ranges_cluster with
+                cluster_nuploading = r.range_nuploading } in
+            if debug_all then
+              lprint_newline ();
+            if is_dummy_cluster acc then cluster
+            else
+              (* find a range with as few uploaders as possible *)
+              let cmp = compare acc.cluster_nuploading
+                cluster.cluster_nuploading in
+              if cmp < 0 then acc
+              else cluster in
+
+        (* fast exit, and why I didn't use an iterator :/ 
+           Could have used an exception, but I don't like that ;) *)
+        if not (is_dummy_cluster best_cluster) &&
+          best_cluster.cluster_nuploading = 0 then b, best_cluster
+        else
+          match r.range_next with
+          | Some rr -> iter best_cluster rr b more_blocks
+          | None -> 
+              match more_blocks with
+              | [] -> b, best_cluster
+              | b :: more_blocks -> 
+                  if debug_all || !verbose then
+                    lprintf_nl "find_range: Client %d, next block" 
+                      (client_num up.up_client);
+                  iter best_cluster b.up_block.block_ranges b more_blocks in
 
       let best_block, best_cluster = 
-	iter dummy_ranges_cluster b.up_block.block_ranges b more_blocks in
+        iter dummy_ranges_cluster b.up_block.block_ranges b more_blocks in
       if not (is_dummy_cluster best_cluster) &&
-	best_cluster.cluster_nuploading > 0 &&
-	(file_downloaded t.t_file < file_size t.t_file ** 98L // 100L) then begin
-	(* it seems they're only sucky choices left on that block, is
-	   there really nothing else better elsewhere ? *)
-	let s = b.up_block.block_s in
-	for i = 0 to up.up_ncomplete - 1 do
-	  let block = up.up_complete_blocks.(i) in
-	  if not (List.exists (fun b -> b.up_block.block_num = block
-			      ) up.up_blocks) then
-	    if should_download_block s block then (* priority bitmap <> 0 here ? *)
-	      let partial_found = match s.s_blocks.(block) with
-		| EmptyBlock -> true
-		| CompleteBlock | VerifiedBlock -> false
-		| PartialBlock b -> b.block_unselected_remaining > 0L in
-	      if partial_found then begin
+        best_cluster.cluster_nuploading > 0 &&
+        (file_downloaded t.t_file < file_size t.t_file ** 98L // 100L) then begin
+        (* it seems they're only sucky choices left on that block, is
+           there really nothing else better elsewhere ? *)
+        let s = b.up_block.block_s in
+        for i = 0 to up.up_ncomplete - 1 do
+          let block = up.up_complete_blocks.(i) in
+          if not (List.exists (fun b -> b.up_block.block_num = block
+                              ) up.up_blocks) then
+            if s.s_priorities_bitmap.[block] <> priority_zero && 
+              should_download_block s block then
+              let partial_found = match s.s_blocks.(block) with
+                | EmptyBlock -> true
+                | CompleteBlock | VerifiedBlock -> false
+                | PartialBlock b -> b.block_unselected_remaining > 0L in
+              if partial_found then begin
 (*
-		if debug_all || !verbose then
-		  lprintf_nl "find_range: Client %d better switch cluster now!" 
-		    (client_num up.up_client);
+                if debug_all || !verbose then
+                  lprintf_nl "find_range: Client %d better switch cluster now!" 
+                    (client_num up.up_client);
 *)
-		raise Not_found
-	      end
-	done
+                raise Not_found
+              end
+        done
       end;
       match List.rev best_cluster.cluster_ranges with
       | [] -> 
-	  if debug_all then
-	    lprintf_nl "find_range: no correct range found!";
-	  raise Not_found
+          if debug_all then
+            lprintf_nl "find_range: no correct range found!";
+          raise Not_found
       | r :: q ->
-	  if not (List.for_all (merge_ranges r) q) then
-	    lprintf_nl "find_range: ranges did not merge as well as planned";
-	  split_range r (min (r.range_begin ++ range_size)
-	   best_block.up_block_end);
-	  if debug_all then begin
-	    lprintf "=> ";
-	    iter_block_ranges (fun rr ->
-	      let selected = if rr == r then "*" else "" in
-	      lprintf " %s[%Ld-%Ld]:%d%s" selected 
-		rr.range_begin rr.range_end rr.range_nuploading
-		selected
-	    ) best_block.up_block;
-	    lprint_newline ();
-	  end;
-	  let key = r.range_begin, r.range_end, r in
-	  up.up_ranges <- up.up_ranges @ [key];
-	  if r.range_nuploading = 0 then begin
-	    let b = r.range_block in
-	    b.block_unselected_remaining <-
-	      b.block_unselected_remaining -- (compute_range_size r);
-	    if b.block_unselected_remaining < 0L then
-	      lprintf_nl "find_range: block_unselected_remaining is negative!";
-	  end;
-	  r.range_nuploading <- r.range_nuploading + 1;
-	  key
+          if not (List.for_all (merge_ranges r) q) then
+            lprintf_nl "find_range: ranges did not merge as well as planned";
+          split_range r (min (r.range_begin ++ range_size)
+           best_block.up_block_end);
+          if debug_all then begin
+            lprintf "=> ";
+            iter_block_ranges (fun rr ->
+              let selected = if rr == r then "*" else "" in
+              lprintf " %s[%Ld-%Ld]:%d%s" selected 
+                rr.range_begin rr.range_end rr.range_nuploading
+                selected
+            ) best_block.up_block;
+            lprint_newline ();
+          end;
+          let key = r.range_begin, r.range_end, r in
+          up.up_ranges <- up.up_ranges @ [key];
+          if r.range_nuploading = 0 then begin
+            let b = r.range_block in
+            b.block_unselected_remaining <-
+              b.block_unselected_remaining -- (compute_range_size r);
+            if b.block_unselected_remaining < 0L then
+              lprintf_nl "find_range: block_unselected_remaining is negative!";
+          end;
+          r.range_nuploading <- r.range_nuploading + 1;
+          key
 
 (** range accessor(s) *)
 
@@ -2706,9 +2801,9 @@ let received up file_begin str string_begin string_len =
   let debug_bad_write unexpected_intervals =
     if !verbose_swarming then begin
       lprintf "Dismiss unwanted data from %d for %s:" 
-	(client_num up.up_client) (file_best_name t.t_file);
+        (client_num up.up_client) (file_best_name t.t_file);
       List.iter (fun (i_begin, i_end) -> 
-	lprintf " %Ld-%Ld" i_begin i_end) unexpected_intervals;
+        lprintf " %Ld-%Ld" i_begin i_end) unexpected_intervals;
       lprint_newline ();
       lprintf_nl "  received: file_pos:%Ld string:%d %d"
         file_begin string_begin string_len;
@@ -2754,24 +2849,24 @@ let received up file_begin str string_begin string_len =
     (* DEBUG *)
     let intervals_out = 
       let remove_interval intervals interval_begin interval_end =
-	let rec remove acc intervals =
-	  match intervals with 
-	  | [] -> List.rev acc
-	  | ((fi_begin, fi_end) as first_interval) :: others ->
-	      if fi_begin >= interval_end then
-		List.rev_append acc intervals 
-	      else if fi_end <= interval_begin then
-		remove (first_interval :: acc) others
-	      else 
-		remove (
-		  let acc = if fi_begin < interval_begin then
-		    (fi_begin, interval_begin) :: acc else acc in
-		  let acc = if fi_end > interval_end then
-		    (interval_end, fi_end) :: acc else acc in
-		  acc) others in
-	remove [] intervals in
+        let rec remove acc intervals =
+          match intervals with 
+          | [] -> List.rev acc
+          | ((fi_begin, fi_end) as first_interval) :: others ->
+              if fi_begin >= interval_end then
+                List.rev_append acc intervals 
+              else if fi_end <= interval_begin then
+                remove (first_interval :: acc) others
+              else 
+                remove (
+                  let acc = if fi_begin < interval_begin then
+                    (fi_begin, interval_begin) :: acc else acc in
+                  let acc = if fi_end > interval_end then
+                    (interval_end, fi_end) :: acc else acc in
+                  acc) others in
+        remove [] intervals in
       List.fold_left (fun acc (_, _, r) ->
-	remove_interval acc r.range_begin r.range_end
+        remove_interval acc r.range_begin r.range_end
       ) [(file_begin, file_end)] up.up_ranges in
     if intervals_out <> [] then
       debug_bad_write intervals_out;
@@ -2786,45 +2881,45 @@ let received up file_begin str string_begin string_len =
     | FileNew
     | FileQueued
     | FileDownloaded -> 
-	if !verbose then
-	  lprintf_nl "received: wrong file state %s for %s" (string_of_state (file_state t.t_file)) s.s_filename;
-	()
+        if !verbose then
+          lprintf_nl "received: wrong file state %s for %s" (string_of_state (file_state t.t_file)) s.s_filename;
+        ()
     | FileDownloading ->
-	try
-	  List.iter (fun (_,_,r) ->
+        try
+          List.iter (fun (_,_,r) ->
     (* was: r.range_begin < file_end && r.range_end > file_begin *)
             if r.range_begin >= file_begin &&
               r.range_begin < file_end then 
-		let file_end = min file_end r.range_end in
-		let written_len = file_end -- r.range_begin in
+                let file_end = min file_end r.range_end in
+                let written_len = file_end -- r.range_begin in
                 let string_pos = string_begin +
                   Int64.to_int (r.range_begin -- file_begin) in
                 let string_length = Int64.to_int written_len in
                   if string_length > 0 then
-		    match s.s_networks with
+                    match s.s_networks with
                     | [] -> assert false
-		    | tprim :: _ ->
-			assert (tprim.t_primary);
-			(try
-			  preallocate_disk_space tprim 
-			    r.range_begin file_end
-			with
-			  End_of_file -> ()
-			| e ->
-			  lprintf_nl "Exception %s while preallocating disk space [%Ld-%Ld] for %s"
-			    (Printexc2.to_string e) 
-			    r.range_begin file_end
-			    (file_best_name t.t_file));
+                    | tprim :: _ ->
+                        assert (tprim.t_primary);
+                        (try
+                          preallocate_disk_space tprim 
+                            r.range_begin file_end
+                        with
+                          End_of_file -> ()
+                        | e ->
+                          lprintf_nl "Exception %s while preallocating disk space [%Ld-%Ld] for %s"
+                            (Printexc2.to_string e) 
+                            r.range_begin file_end
+                            (file_best_name t.t_file));
                         file_write tprim.t_file
                           r.range_begin
                           str string_pos string_length;
-			range_received (Some t) r r.range_begin file_end;
-	  ) up.up_ranges;
-	  remove_completed_uploader_ranges up
-	with e ->
-	  lprintf_nl "Exception %s while receiving data"
-	    (Printexc2.to_string e);
-	  remove_completed_uploader_ranges up;
+                        range_received (Some t) r r.range_begin file_end;
+          ) up.up_ranges;
+          remove_completed_uploader_ranges up
+        with e ->
+          lprintf_nl "Exception %s while receiving data"
+            (Printexc2.to_string e);
+          remove_completed_uploader_ranges up;
           raise e
 
 (** compute the list of present intervals of a swarmer *)
